<?php

/**
 * Fired during plugin activation
 *
 * @link       www.teowin.nl
 * @since      1.0.0
 *
 * @package    Pw
 * @subpackage Pw/includes
 */

/**
 * Fired during plugin activation.
 *
 * This class defines all code necessary to run during the plugin's activation.
 *
 * @since      1.0.0
 * @package    Pw
 * @subpackage Pw/includes
 * @author     Teowin <plugins@teowin.nl>
 */
class Pw_Activator {

	/**
	 * Add events to the cron scheduler.
	 * @since    1.0.0
	 */
	public static function activate() { 
  
      // schedule cron job
		if ( ! wp_next_scheduled( 'teowin_sync_powerall_products' ) ) {
			wp_schedule_event( time(), '30min', 'teowin_sync_powerall_products' );
		}

		if ( ! wp_next_scheduled( 'teowin_sync_powerall_users' ) ) {
			wp_schedule_event( time(), '30min', 'teowin_sync_powerall_users' );
		}

	//	if ( ! wp_next_scheduled( 'teowin_sync_powerall_statusses' ) ) {
	//		wp_schedule_event( time(), '30min', 'teowin_sync_powerall_orderstatusses' );
	//	}

        	if ( ! wp_next_scheduled( 'teowin_sync_test_cron' ) ) {
		    // wp_schedule_event( time(), 'iedere_minuut', 'teowin_sync_test_cron' );
        	}

        update_site_option('powerall_sync', false);
	}

}
