<?php

defined( 'ABSPATH' ) || exit;

/**
 * register custom product class
 */

function register_pw_product() {

	// Make sure WooCommerce is active
	if ( ! in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) return;

	class WC_Product_Powerall extends WC_Product {

		public $product_type = 'pw_product';
		public $virtual = 'no';
		public $downloadable = 'no';
		public $manage_stock = 'yes';

	/*	public function __construct() {
       //   leave the constructor out, otherwise the product is "simple" and won't save.
			parent::__construct();

			$this->virtual = 'yes';
		$this->downloadable = 'no';
		$this->manage_stock = 'no';
	 } */


        /**
         * Get internal type.
         * @return string
         */

		public function get_type() {
			return 'pw_product';
		}
		
		
		public function is_purchasable() {
			return true;
		}


		

	}



}
if ( in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) {
    add_action('init', 'register_pw_product');
}

function powerall_product_class( $classname, $product_type ) {

	if ( $product_type == 'pw_product' ) {
		$classname = 'WC_Product_Powerall';
	}

	return $classname;
}

if ( in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) {
    add_filter('woocommerce_product_class', 'powerall_product_class', 10, 2);
}



//add_action( 'wp_ajax_my_action', 'my_action' );


//add_action( 'woocommerce_single_product_summary', 'powerall_template', 60 );
function powerall_template () {
	global $product;
	if ( 'pw_product' == $product->get_type() ) {
		$template_path = plugin_dir_path( __FILE__ ) . 'templates/';
		// Load the template

		wc_get_template( 'single-product/add-to-cart/powerall_fields_template.php',
			'',
			'',
			trailingslashit( $template_path ) );
	}
}

add_action('woocommerce_order_status_changed', 'woo_order_status_change_custom', 10, 3);
function woo_order_status_change_custom($order_id,$old_status,$new_status) {

 	$order = new WC_Order( $order_id );

	if ($old_status === 'pending' && $new_status === 'on-hold' ){
	    // Typical when a customer payment term is > 1.
		$temp        = $order->get_customer_id();
		if ($temp) {
			$powerallID  = get_user_meta( $temp, '_powerallid', true );
			$paymentTerm = (int) get_user_meta( $temp, 'paycondition', true );

            if ( isset($paymentTerm) && isset($powerallID) && ($paymentTerm > 1 )) {
                // Powerall klant die op rekening koopt.
                $order->set_status('wc-powerall-ready', 'Changed Pending to Powerall-Ready');

            }
		}
    }
}

add_action( 'save_post_shop_order', 'process_offline_order', 10, 3 );
function process_offline_order( $post_id, $post, $update ){

	// Orders in backend only
//	if( ! is_admin() ) return;

	// Get an instance of the WC_Order object (in a plugin)
	$order = new WC_Order( $post_id );

	// For testing purpose
	$trigger_status = get_post_meta( $post_id, '_hook_is_triggered', true );

	// 1. Fired the first time you hit create a new order (before saving it)
	if( ! $update )
		update_post_meta( $post_id, '_hook_is_triggered', 'Create new order' ); // Testing

	if( $update ){
		// 2. Fired when saving a new order
		if( 'Create new order' == $trigger_status ){
			update_post_meta( $post_id, '_hook_is_triggered', 'Save the new order' ); // Testing

            // Status = on-hold
		}
		// 3. Fired when Updating an order
		else{
			update_post_meta( $post_id, '_hook_is_triggered', 'Update  order' ); // Testing
		}
	}
}

// add_action('woocommerce_checkout_create_order', 'duplicate_pickup_date_meta', 20, 2);
function duplicate_pickup_date_meta( $order, $data ) {
//	$items = $order->get_items('shipping');
//	foreach ( $items as $item ) {
//		$zap_pickup_date_value = $item['_pickup_date'];
//	}
//	$order->update_meta_data( 'zapier_pickupdate', $zap_pickup_date_value );
}


function powerall_woocommerce_payment_complete( $order_id ) {

	error_log( "Payment has been received for order $order_id" );

	do_action('woocommerce_order_status_powerall-ready', $order_id);

}

add_action( 'woocommerce_payment_complete', 'powerall_woocommerce_payment_complete', 10, 1 );
//add_action( 'woocommerce_order_status_completed', 'powerall_woocommerce_payment_complete', 10, 1 );



/*
// Save item custom fields label and value as order item meta data -> the invoiceline.
add_action('woocommerce_add_order_item_meta','save_in_order_item_meta', 10, 3 );
function save_in_order_item_meta( $item_id, $values, $cart_item_key ) {

	if( isset( $values['_Serials'] )) {

		$product_serials = $values['_Serials'];

		if ( ! is_array( $product_serials ) ) {
			foreach ( $product_serials as $lineitem ) {
				$serialtype = $lineitem['SerialType'];
				$serial     = $lineitem['Serial'];

				wc_add_order_item_meta( $item_id, 'Serial', $serial, false );
			}
		}
	}


}*/




/**
 * Filterting the meta data of an order item.
 * @param  array         $meta_data Meta data array
 * @param  WC_Order_Item $item      Item object
 * @return array                    The formatted meta
 */

// add_filter( 'woocommerce_order_item_get_formatted_meta_data', 'change_formatted_meta_data', 20, 2 );
function change_formatted_meta_data( $meta_data, $item ) {
	$new_meta = array();
	foreach ( $meta_data as $id => $meta_array ) {
		// We are removing the meta with the key 'something' from the whole array.
		if ( 'something' === $meta_array->key ) { continue; }
		$new_meta[ $id ] = $meta_array;
	}
	return $new_meta;
}

// Order pages (frontend and admin): Display extra data
add_action( 'woocommerce_order_details_after_order_table' , 'powerall_display_admin_order_meta', 20, 1 ); // Front
add_action( 'woocommerce_admin_order_data_after_billing_address', 'powerall_display_admin_order_meta', 20, 1 ); // Admin

function powerall_display_admin_order_meta( $order ){

    // the ORDER meta, not the ITEM meta.
    $orderdatum = $order->get_meta('_powerallOrderDate', true);
    $orderid = $order->get_meta('_powerallOrderID', true);


	if( !empty( $orderid ) ){
		$labeldatum = __('Powerall Orderdatum', 'twpowerall');
		$labelorderid = __('Powerall Ordernummer', 'twpowerall');
		// $labeldatum = __('Powerall Orderdatum:', 'twpowerall');
		if( is_admin() ){ // Admin
			echo '<p>' . $labeldatum . ':<h2>' . $orderdatum . '</h2></br>';
			echo $labelorderid . ':<h2>' . $orderid . '</h2></p>';
		}
		else { // Front end: order view and Order received (thankyou)

			echo '<table class="woocommerce-table woocommerce-table--order-details shop_table order_details"><tbody><tr>
                <td>' . $labeldatum . ':</td><td>' . $orderdatum . '</td>
            </tr> <tr>
                <td>' . $labelorderid . ':</td><td><strong>' . $orderid . '</strong></td>
            </tr>
            </tbody></table>';
		}
	}
}

// Email notifications: Display custom field "serial"
//add_filter( 'woocommerce_email_order_meta_fields' , 'powerall_display_email_metadata', 20, 3 );
function powerall_display_email_metadata( $fields, $sent_to_admin, $order ) {

	// Meta fields on ORDER level!

	$serial = $order->get_meta('_Serial', true );
	$serialtype = $order->get_meta('_SerialType', true);

	if ($serialtype == 'text/plain'){
		$serialtext = $serial;
	}
	else if (($serialtype == 'image/jpeg') || ($serialtype == 'image/png') || ($serialtype == 'image/gif')){
		$serialtext = '<img src=â€�data:<' . $serialtype . ';basee64,' . $serial . '">';

	}
	else {
		return;
	}

	if( ! empty( $serial ) )
		$fields['serialinfo'] = array(
			'label' => __("Serial", 'twpowerall'),
			'value' => $serial,
		);
	return $fields;
}


//add_filter( 'woocommerce_payment_complete_order_status', 'powerall_order_complete_order_status', 10, 2 );

function powerall_order_complete_order_status( $order_status, $order_id ) {

	$order = wc_get_order( $order_id );
	if ('processing' == $order_status && ( 'on-hold' == $order->status || 'pending' == $order->status || 'failed' == $order->status ))  {

		if ( null !== $order->get_date_paid()) {

			$virtual_order = null;

			if ( count( $order->get_items() ) > 0 ) {

				foreach ( $order->get_items() as $item ) {

					if ( 'line_item' == $item['type'] ) {

						$_product = $item->get_product();

						$virtual_order = false;

						if ( 'pw_product' == $_product->get_type() ) {
							$virtual_order = false;
							break;
						}
						/*
						if ( ! $_product->is_virtual() ) {
							// once we've found one non-virtual product we know we're done, break out of the loop
							$virtual_order = false;
							break;
						} else {
							$virtual_order = true;
						} */
					}
				}
			}

			// virtual order, mark as completed
			if ( $virtual_order ) {
				return 'completed';
			}
		}
	}

	// non-virtual order, return original status
	return $order_status;
}

// register a custom post status 'poweral status' for Orders
add_action( 'init', 'register_custom_post_status', 20 );
function register_custom_post_status() {
	register_post_status( 'wc-powerall-issue', array(
		'label'                     => _x( 'Powerall API issue', 'Order status', 'twpw' ),
		'public'                    => true,
		'exclude_from_search'       => false,
		'show_in_admin_all_list'    => true,
		'show_in_admin_status_list' => true,
		'label_count'               => _n_noop( 'Powerall API issue <span class="count">(%s)</span>', 'Powerall API issues: <span class="count">(%s)</span>', 'twpw' )
	) );

	register_post_status( 'wc-powerall-ready', array(
		'label'                     => _x( 'Ready for Powerall', 'Order status', 'twpw' ),
		'public'                    => true,
		'exclude_from_search'       => false,
		'show_in_admin_all_list'    => true,
		'show_in_admin_status_list' => true,
		'label_count'               => _n_noop( 'Powerall Ready <span class="count">(%s)</span>', 'Powerall Ready: <span class="count">(%s)</span>', 'twpw' )
	) );

	register_post_status( 'wc-powerall-sent', array(
		'label'                     => _x( 'Sent to Powerall', 'Order status', 'twpw' ),
		'public'                    => true,
		'exclude_from_search'       => false,
		'show_in_admin_all_list'    => true,
		'show_in_admin_status_list' => true,
		'label_count'               => _n_noop( 'Sent to Powerall <span class="count">(%s)</span>', 'Sent to Powerall: <span class="count">(%s)</span>', 'twpw' )
	) );
}

// Adding custom status 'awaiting-delivery' to order edit pages dropdown
add_filter( 'wc_order_statuses', 'custom_wc_order_statuses' );
function custom_wc_order_statuses( $order_statuses ) {
	$order_statuses['wc-powerall-issue'] = _x( 'PowerAll API issue', 'Order status', 'twpw' );
	$order_statuses['wc-powerall-ready'] = _x( 'PowerAll Ready', 'Order status', 'twpw' );
	$order_statuses['wc-powerall-sent'] = _x( 'Sent to Powerall', 'Order status', 'twpw' );
	return $order_statuses;
}

// Adding custom status 'awaiting-delivery' to admin order list bulk dropdown
add_filter( 'bulk_actions-edit-shop_order', 'custom_dropdown_bulk_actions_shop_order', 20, 1 );
function custom_dropdown_bulk_actions_shop_order( $actions ) {
	$actions['wc-powerall-issue'] = _x( 'PowerAll API issue', 'Order status', 'twpw' );
	$actions['wc-powerall-ready'] = _x( 'PowerAll Ready', 'Order status', 'twpw' );
	$actions['wc-powerall-sent'] = _x( 'Sent to Powerall', 'Order status', 'twpw' );
	return $actions;
}

// Adding action for 'awaiting-delivery'
add_filter( 'woocommerce_email_actions', 'custom_email_actions', 20, 1 );
function custom_email_actions( $action ) {
	$actions[] = 'woocommerce_order_status_wc-powerall-issue';
	return $actions;
}

function add_expedited_order_woocommerce_email( $email_classes ) {

	// include our custom email class
	require( plugin_dir_path( dirname( __FILE__ )) . 'includes/class-pw-email.php' );

	// add the email class to the list of email classes that WooCommerce loads
	$email_classes['WC_Powerall_related_Email'] = new WC_Powerall_related_Email();

	return $email_classes;

}
add_filter( 'woocommerce_email_classes', 'add_expedited_order_woocommerce_email' );

// add_action( 'woocommerce_order_status_wc-powerall-issue',  'send_transactional_email', 10, 1 );
//add_action( 'woocommerce_order_status_powerall-issue',  'awaiting_delivery_order_status_email_notification', 10, 1 );

// Sending an email notification when order get 'awaiting-delivery' status
add_action('woocommerce_order_status_wc-powerall-issue', 'awaiting_delivery_order_status_email_notification', 20, 2);
function awaiting_delivery_order_status_email_notification( $order_id) {
	// HERE below your settings
	$heading   = __('Powerall API issue - Check website','twpw');
	$subject   = '[{site_title}] issue met uitwisseling met Powerall API (order: {order_number}) ';

	// The email notification type
	$email_key   = 'WC_Powerall_related_Email';

	// Get specific WC_emails object
	$email_obj = WC()->mailer()->get_emails()[$email_key];

	// Sending the customized email
	$email_obj->trigger( $order_id );
}



add_action( 'woocommerce_order_status_powerall-ready',  'send_order_to_powerall', 10, 1 );
function send_order_to_powerall( $order_id) {
	error_log( "send_order_to_powerall " . $order_id );

	$order = wc_get_order( $order_id );


	$powerallorderid = $order->get_meta('_powerallOrderID', true );

	// New order so prepare and send to Powerall API.
	if ( empty( $powerallorderid ) ) {

        error_log( "send_order_to_powerall new order, sending it to Powerall " . $order_id );

		$pworder = array();

		//	$tempTax = get_option('powerall_taxes')
		$tempShipmentList = get_option('powerall_shipment');

		if (!$tempShipmentList) {
			/* WHOOPS -> geen verzendwijze maar wel een order? */
			$order->set_status( 'wc-powerall-issue', 'Shipment list not set in plugin opties');
			$order->save();
			return('error');
		} else {
			foreach ( $tempShipmentList as $shipment ) {
				if ( $order->has_shipping_method( $shipment['wooShipId'] ) ) {
					$pworder['ExpeditionCode'] = $shipment['pwShipId'];
				}
			}

			if (!$pworder['ExpeditionCode']) {
				$order->set_status( 'wc-powerall-issue', 'Delivery condition not found');
				$order->save();
			    wp_die();
            }
		}

		//	$tempTax = get_option('powerall_taxes')
		$tempPaymentList = get_option('powerall_payment');

		if (!$tempPaymentList) {
			/* WHOOPS -> geen verzendwijze maar wel een order? */
			$order->set_status( 'wc-powerall-issue', 'Payment list not set in plugin opties');
			$order->save();
			return('error');
		} else {
			foreach ( $tempPaymentList as $payment ) {
				if ( $order->get_payment_method() == $payment['wooPayId'] ) {
					$pworder['PayCondition'] = $payment['pwPayId'];
				}
			}

			if (!$pworder['PayCondition']) {
				$order->set_status( 'wc-powerall-issue', 'Payment condition not found');
				$order->save();
				wp_die();
			}
		}


		$temp       = $order->get_customer_id();

		$powerallID = get_user_meta( $temp, 'powerall_id', true );

		if ($temp == 0 ){
		    // No Powerall customer.
           $powerallID = get_option('contantfactdebiteur');

           if (!$powerallID){
              $order->set_status( 'wc-powerall-issue', 'Geen contantfactuurdebiteurnummer ingesteld bij Woo opties');
              exit;
           }
        }


		// It is possible for an unknown customer to place an order. This unknown customer is now registered in Woocommerce but not
        // known by Powerall. So we send it to Powerall as "cashinvoice (contantfactuur).
//		if (!$powerallID){
//		    // okay, we got ourselves a webshop only customer. Send him to Powerall.
//          $customer = new WC_Customer($temp);
//          $billing_adress   = $customer->get_billing('view');
//          $shipment_address = $customer->get_shipping('view');
//
//		  $new_customer = array();
//
//		  $new_customer['Id']            = $customer->get_id();
//		  $new_customer['Name']          = $customer->get_billing_company();
//		  $new_customer['Address']       = $customer->get_billing_address_1();
//		  $new_customer['ZipCode']       = $customer->get_billing_postcode();
//		  $new_customer['Town']          = $customer->get_billing_city();
//		  $new_customer['CountryCode']   = 'nl';
//		  $new_customer['Phone']         = $customer->get_billing_phone();
//		  $new_customer['ContactPerson'] = $customer->get_billing_first_name() . ' ' . $customer->get_billing_last_name();
//		  $new_customer['EmailAddress']  = $customer->get_billing_email();
//		  $new_customer['IsBusiness']    = 'true';
//
//          $pwDropShipment = PwDropShipment::get_instance();
//          $result   = $pwDropShipment->powerall_create_customer( $new_customer );
//
//          if ( $result['code'] != '200' ) {
//              $order->set_status( 'wc-powerall-issue', 'Toevoegen van nieuwe klant bij powerall is niet gelukt: ' . $result['message'] );
//              exit;
//          }
//
//          $powerallID = get_option('contantfactdebiteur');
//
//          // This temporary user should be deleted since it is impossible to find him when synchronizing.
//          update_user_meta($temp, 'powerall_id',   $powerallID );
//
//          if (!$powerallID){
//              $order->set_status( 'wc-powerall-issue', 'Geen contantfactuurdebiteurnummer ingesteld bij Woo opties');
//              exit;
//          }
//        }



		$pworder['Id']                  = $order->get_order_number();
		$pworder['CustomerId']          = $powerallID;
		$pworder['OrderDate']           = date('Y-m-d' );
		$pworder['Reference']           = $order->get_customer_note();
		$pworder['EmailAddress']        = $order->get_billing_email();

		$pworder['InvoiceName']         = $order->get_billing_company();
		if ($pworder['InvoiceName'] == ''){
            $pworder['InvoiceName'] = $order->get_billing_first_name()  . ' ' . + $order->get_billing_last_name();
        }

		$pworder['InvoiceAddress']      = $order->get_billing_address_1() . ' ' . $order->get_billing_address_2();
		$pworder['InvoiceZipCode']      = $order->get_billing_postcode();
		$pworder['InvoiceTown']         = $order->get_billing_city();
		$pworder['InvoiceCountryCode']  = 'nl';
		//	$pworder['DeliverySequenceNumber'] = '0';

        if ($order->get_shipping_company() != '') {
            $pworder['DeliveryName'] = $order->get_shipping_company();
        } else {
            $pworder['DeliveryName'] = $order->get_shipping_first_name() . ' ' . $order->get_shipping_last_name();
        }
		$pworder['DeliveryAddress']     = $order->get_shipping_address_1() . ' ' . $order->get_shipping_address_2();
		$pworder['DeliveryZipCode']     = $order->get_shipping_postcode();
		$pworder['DeliveryTown']        = $order->get_shipping_city();
		$pworder['DeliveryCountryCode'] = 'nl';
		$pworder['OrderType']           = '1';
		$pworder['DeliveryCondition']   = '99'; // Overlegd met Bever
		$pworder['PriceType']           = 'ExcludingVat';
		$pworder['TotalPriceExVat']     = $order->get_total();
		$pworder['TotalPriceIncVat']    = $order->get_total() + $order->get_total_tax();


		// Loop through order items
		foreach ( $order->get_items() as $item ) {
			$lines   = array();
			$product = wc_get_product( $item->get_product_id() );

			$btw       = 21;
			$tax_rates = WC_Tax::get_rates( $product->get_tax_class() );
			if ( ! empty( $tax_rates ) ) {
				$tax_rate = reset( $tax_rates );
				$btw      = $tax_rate['rate'];
			}

			$lines['ProductCode'] = $product->get_sku();
			// $lines['GrossPrice']  =
			$test  = $product->get_regular_price();
			$fiets = $product->get_price();
			//	$product_id = $item->get_product_id();
			//	$variation_id = $item->get_variation_id();
			//	$product = $item->get_product();
			$lines['Description'] = $item->get_name();
			$lines['Quantity']    = $item->get_quantity();

			$subtotal               = $item->get_subtotal();
			$total                  = $item->get_total();
			$lines['VatPercentage'] = $btw;
			$lines['GrossPrice']    = $item->get_total() / $item->get_quantity();
			$lines['NetPrice']      = $item->get_subtotal() / $item->get_quantity();
			//	$taxclass = $item->get_tax_class();
			//	$taxstat = $item->get_tax_status();
			//	$allmeta = $item->get_meta_data();
			//	$somemeta = $item->get_meta( '_whatever', true );
			//	$type = $item->get_type();



			$pworder['lines'][] = $lines;
		}


		$shipping_costs = array();
		foreach($order->get_items( 'shipping' ) as $shipping_method ){

			$method_id = $shipping_method->get_id() ;
		//	$shipping_method_name = $shipping_method->get_name();
			$shipping_method_title = $shipping_method->get_method_title();
			$shipping_method_total = $shipping_method->get_total();
		//	$shipping_method_total_tax = $shipping_method->get_total_tax();


			$shipping_method_tax = 21;
			$tax_rates = WC_Tax::get_rates( $shipping_method->get_tax_class());
			if ( ! empty( $tax_rates ) ) {
				$tax_rate = reset( $tax_rates );
				$shipping_method_tax = $tax_rate['rate'];
			}

			$shipping_costs['ProductCode']   = $method_id;
			$shipping_costs['Description']   = $shipping_method_title;
			$shipping_costs['Quantity']      = '1';
			$shipping_costs['VatPercentage'] = $shipping_method_tax;
			$shipping_costs['Grossprice']    = $shipping_method_total;
			$shipping_costs['Netprice']      = $shipping_method_total;
			$pworder['lines'][] = $shipping_costs;
		}


		if ( isset( $pworder ) ) {
			/*
			*  Time to place the order.
			*/

			$pwDropShipment = PwDropShipment::get_instance();
			$order_data   = $pwDropShipment->powerall_place_order( $pworder );
		}

		if ( $order_data['code'] == '200' ) {

			$order->update_meta_data('_powerallOrderID', $order->get_order_number());
			$order->set_status( 'wc-powerall-sent', 'Order naar PowerAll API gestuurd.');

		} else {
			$order->set_status( 'wc-powerall-issue', 'Toevoegen van order bij powerall is niet gelukt: ' . $order_data['error'] );

		}

		$order->save();
	}
}

add_action('admin_head', 'styling_admin_order_list' );
function styling_admin_order_list() {
    global $post;
    if (!$post) return;
    
	global $pagenow, $post;

	if( $pagenow != 'edit.php') return; // Exit
	if( get_post_type($post->ID) != 'shop_order' )  return; // Exit

	// HERE we set your custom status
	$order_status = 'wc-powerall-issue';

	?>
    <style>
       .mark order-status status-powerall-issue  {
            background: red !important;
            color: white !important;
        }
   </style>
   <?php
}


//  Disable gateway based on payment conditions IF customer
function payment_gateway_disable_op_rekening( $available_gateways ) {

    if (WC()->customer) {

        $cust_id = WC()->customer->get_id();

        if ($cust_id) {
            $paymentTerm = (int)get_user_meta($cust_id, 'paycondition', true);


            if (($paymentTerm > 0) && ($paymentTerm < 50 || $paymentTerm > 60)) {
                if (isset($available_gateways['powerall'])) {
                    unset($available_gateways['powerall']);
                }
            } else {
                if (isset($available_gateways['powerall'])) {
                    $available_gateways = array('powerall' => $available_gateways['powerall']);
                }
            }
        } else {
            if (isset($available_gateways['powerall'])) {
                unset($available_gateways['powerall']);
            }
        }
    }

	return $available_gateways;

}
add_filter( 'woocommerce_available_payment_gateways', 'payment_gateway_disable_op_rekening' );

/*
 * Example adds certain named Product Attribute fields to the product Edit screen ready for completion.
 * (Pre-requisite )
 * This saves the Shop Admin having to add them manually.
 *
 * Why might you want to do this instead of adding Custom fields?  There's plenty of nice documentation on adding custom fields
 * for example: http://www.remicorson.com/mastering-woocommerce-products-custom-fields/
 *
 * Well a Product Attributes are a built in WooCommerce feature, using Terms which are a built in Wordpress feature.
 * - no add-ons required
 * - pre-existing functionality including
 *   - ability to link from Product to archive page of products sharing the same term
 *   - Term selection, hide or show Attribute, use for Product Variations
 *   - built-in configuration screens, display and selection mechanisms
 * - highly compatible with plugin components for example to
 *   - enhance Product Attributes display,
 *   - show Variation swatches,
 *   - translate Attributes and terms
 * - offers a level of separation between built-in fields and extension fields
 * (though custom fields can be added to their own tab, and some fields make sense to add to other tabs)
 *
 */


/*
 * Create a default Product Attribute object for the supplied name
 *
 * @param  string   name        Product Attribute taxonomy name
 *
 * @return WC_Product_Attribute/bool  new Attribute or false if named Attribute is not found
 *
 */
function acme_make_product_attribute($name)
{
    global $wc_product_attributes;
    if ( !isset($wc_product_attributes[$name]) ){
        $newattr = new WC_Product_Attribute();
        $newattr->set_id(-1);  //any positive value is interpreted as is_taxonomy=true
        $newattr->set_name($name);
        $newattr->set_visible(false);
        $newattr->set_variation(true);
        //example of setting default value for item
        if ($name=='pa_brand'){
            $term = get_term_by('slug', 'acme', $name);
         //   $newattr->set_options(array($term->term_id));
        }
        return $newattr;
    } else {
        return false;
    }
}
/*
 * Add default attributes to a product
 */
function acme_default_product_attributes()
{
    global $product;
    if (! $product) {
        $product = $GLOBALS['product_object'];
    }
    if (! $product) {
        return;
    }
    $attributes = $product->get_attributes();
    
    $defaultAttributes = array(
        'pa_brand',
        'pa_maker',
        'pa_materials',
        'pa_asin',
        'pa_upc',
        'pa_packaging',
        'pa_recommend-to',
        'pa_suitable-for',
        'pa_product-size',
        'pa_net-weight',
    );
    
    $changed=false;
    foreach ($defaultAttributes as $key){
        if (! isset($attributes[$key])){
            $newattr = acme_make_product_attribute($key);
            if ($newattr){
                $attributes[$key] = $newattr;
            }
            $changed = true;
        }
    }
    if ($changed){
        $product->set_attributes($attributes);
    }
}
/*
 * added to last hook before rendering of Product Edit screen
 */
//add_action('woocommerce_product_write_panel_tabs', 'acme_default_product_attributes');
